Codeforces 583C GCD Table【贪心】

C. GCD Table
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

The GCD table G of size n × n for an array of positive integers a of length n is defined by formula

Let us remind you that the greatest common divisor (GCD) of two positive integers x and y is the greatest integer that is divisor of both x and y, it is denoted as . For example, for array a = {4, 3, 6, 2} of length 4 the GCD table will look as follows:

Given all the numbers of the GCD table G, restore array a.

Input

The first line contains number n (1 ≤ n ≤ 500) — the length of array a. The second line contains n2 space-separated numbers — the elements of the GCD table of G for array a.

All the numbers in the table are positive integers, not exceeding 109. Note that the elements are given in an arbitrary order. It is guaranteed that the set of the input data corresponds to some array a.

Output

In the single line print n positive integers — the elements of array a. If there are multiple possible solutions, you are allowed to print any of them.

Examples
Input
4
2 1 2 3 4 3 2 6 1 1 2 2 1 2 3 2
Output
4 3 6 2
Input
1
42
Output
42 
Input
2
1 1 1 1
Output
1 1 

题目大意:

给你N*N个数,让你将N*N个数放置到N*N的格子中,使得Aij表示的就是Gcd(Ai,Aj);

输出N个Ai.


思路:


1、首先很显然,对角线上放置的数字,就是结果,那么我们考虑问题的出发点,就是去放置N个对角线上的数字咯。


2、那么如何才能得到答案呢?

①很明显,最大的数字一定是对角线上的数字,因为这个数字只能由Gcd(i,i)得到。

②那么按照这个思路推下去,那么第二个放置在对角线上的数字,肯定就是第二大的数字了,同时对应GCD(最大,次大)的数字要减少两个。

③那么再按照这个思路推下去,那么第三个放置在对角线上的数字,就应该是剩下还有的数字中最大的数字,同时再将对应GCD(最大,这个数字)的数字减少两个;以及GCD(次大,这个数字)减少两个.

④那么依次类推,模拟这个贪心的过程就行了。


Ac代码:

#include<stdio.h>
#include<string.h>
#include<queue>
#include<map>
#include<algorithm>
using namespace std;
int pre[505];
int a[505*505];
int gcd(int a,int b)
{
    if(b==0)return a;
    else return gcd(b,a%b);
}
int main()
{
    int n;
    while(~scanf("%d",&n))
    {
        map<int ,int >s;
        for(int i=0;i<n*n;i++)scanf("%d",&a[i]),s[a[i]]++;;
        sort(a,a+n*n);
        reverse(a,a+n*n);
        int cnt=0;
        for(int i=0;i<n*n;i++)
        {
            if(s[a[i]]>0)
            {
                printf("%d ",a[i]);
                s[a[i]]--;
                for(int j=0;j<cnt;j++)
                {
                    s[gcd(a[i],pre[j])]-=2;
                }
                pre[cnt++]=a[i];
            }
        }
        printf("\n");
    }
}







  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值